import {getCars} from './getCars';

import {generateReport} from './generateReport';
import {dropdownMenu} from './dropdownMenu';
import {scatterPlot} from './scatterPlot';



import {
  select,
  csv,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  format
	} from 'd3' //importujeme potrebne fcie z d3
const svg=select('svg');
const width=+svg.attr('width');
const height=+svg.attr('height');
let data;
let xColumn;
let yColumn;
const onXColumnClicked= column => {
  
 // console.log(column);
  xColumn=column;
  render();
};

const onYColumnClicked= column => {
  
 // console.log(column);
  yColumn=column;
  render();
};


const render = ()=>{
      select('#x-menu').call(
      dropdownMenu,
        { options:data.columns,
          onOptionClicked: onXColumnClicked,
          selectedOption:xColumn
        
        }
         
    );
      select('#y-menu').call(
      dropdownMenu,
        { options:data.columns,
          onOptionClicked: onYColumnClicked,
          selectedOption:yColumn
        }
        );

svg.call(scatterPlot,{
     
      xValue:d=>d[xColumn],
      yValue:d=>d[yColumn],
      circleRadius:7,
      xAxisLabel:xColumn,
      yAxisLabel:yColumn,
      margin:{top:10,bottom:70,left:150,right:40},
      width:width,
      height:height,
      data:data
         
});
}; 

csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(loadedData =>{
   data=loadedData;
   data.forEach(d =>{
                d.mpg=+d.mpg; //zmena na cislo
                d.cylinders=+d.cylinders;
      					d.displacement=+d.displacement;
                d.horsepower=+d.horsepower;
                d.weight=+d.weight;
                d.acceleration=+d.acceleration;
     						d.year=+d.year;
   });
   xColumn=data.columns[0];
  yColumn=data.columns[4];
    render();
});





