
import {
  scaleLinear,
  extent,
  csv,
  max,
  axisLeft,
  axisBottom,
  format
	} from 'd3' //importujeme potrebne fcie z d3

export const scatterPlot = (selection, props) => {
      const {
      
         xValue,
         yValue,
         circleRadius,
         xAxisLabel,
         yAxisLabel,
         margin,
         width,
         height,
         data
      } =props;
 
  const innerWidth=width-margin.left-margin.right;
  const innerHeight=height-margin.top-margin.bottom;
 // console.log(xAxisLabel);
  
  const xScale=scaleLinear() //instance of scale linear
    .domain(extent(data,xValue)) //extent vracia pole -min,max range
    .range([0,innerWidth])
     .nice();
  
  const yScale=scaleLinear()
  	 .domain(extent(data,yValue))
    .range([0,innerHeight])
    .nice();
 
  const g =selection.selectAll('.container').data([null]);
    const gEnter=g
    		.enter().append('g')
        .attr('class','container');//group element
      gEnter.merge(g)
    		.attr('transform',`translate(${margin.left},${margin.top})`);
  
  
  
  
  
  const xAxisTickFormat=number=>format('.3s')(number)
     .replace('G','B');
  
  const xAxis=axisBottom(xScale)
  		.tickFormat(xAxisTickFormat)
      .tickSize(-innerHeight)
      .tickPadding(12);
  
  const yAxis=axisLeft(yScale)
   .tickSize(-innerWidth)
    .tickPadding(10);
  
  const yAxisG = g.select('.y-axis');
  const yAxisGEnter = gEnter
    .append('g')
      .attr('class', 'y-axis');
  yAxisG
    .merge(yAxisGEnter)
      .call(yAxis)
      .selectAll('.domain').remove();
  
  const yAxisLabelText = yAxisGEnter
    .append('text')
      .attr('class', 'axis-label')
      .attr('y', -93)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .attr('text-anchor', 'middle')
    .merge(yAxisG.select('.axis-label'))
      .attr('x', -innerHeight / 2)
      .text(yAxisLabel);
 
  const xAxisG = g.select('.x-axis');
  const xAxisGEnter= gEnter.append('g') 
     .attr('class','x-axis');
 
  xAxisG
     .merge(xAxisGEnter)
      .attr('transform',`translate(0,${innerHeight})`)
     .call(xAxis)
    .selectAll('.domain').remove();
  
  
  
  xAxisG
    .select('.domain')
    .remove();
  
   const xAxisLabelText=xAxisGEnter
   .append('text')//popis vodorovnej osi
    .attr('class','axis-label')//aby sme to vedeli vyselektovat pre styling
    .attr('y',60)
    .attr('fill','black')
  .merge(xAxisG.select('.axis-label'))
   .attr('x',innerWidth/2)
   .text(xAxisLabel);
  
 
  
  const circles=g.merge(gEnter)
   .selectAll('circle').data(data);
   circles
    .enter().append('circle')
    .attr('cx',innerWidth/2)
    .attr('cy',innerHeight/2)
     .attr('r',0)
    .merge(circles)
    .transition().duration(1500)//prechod y jedneho option selectu na druhy
    .delay((d,i)=>i*10)//pre kazdy puntik ine oneskorenie
    .attr('cy',d=>yScale(yValue(d)))
    .attr('cx',d=>xScale(xValue(d)))
    .attr('r',circleRadius)
  
 

  
};